$NOLIST
;
;********************************************************************************************************
; Ziehen der Quadratwurzel (32 Bit -> 16 Bit)
; J. Rathlev, Jan. 2008
; Diese Datei kann mit der Include-Anweisung in andere Programme integriert werden
;********************************************************************************************************

        DSEG

RADI:   DS      4       ; mssen hintereinander stehen
SQTMP:  DS      7
ROOT:   DS      2

;********************************************************************************************************

        CSEG

;********************************************************************************************************
; RADI nach links schieben, herausgeschobene Bits in SQTMP, von rechts wird mit 0 aufgefllt
; benutzte Register: A,R7
;********************************************************************************************************

DSH162: MOV     R7,#2           ; 2 Bit
DSH16L: CLR     C
        MOV     A,RADI
        RLC     A
        MOV     RADI,A
        MOV     A,RADI+1
        RLC     A
        MOV     RADI+1,A
        MOV     A,RADI+2
        RLC     A
        MOV     RADI+2,A
        MOV     A,RADI+3
        RLC     A
        MOV     RADI+3,A
        MOV     A,SQTMP
        RLC     A
        MOV     SQTMP,A
        MOV     A,SQTMP+1
        RLC     A
        MOV     SQTMP+1,A
        MOV     A,SQTMP+2
        RLC     A
        MOV     SQTMP+2,A
        MOV     A,SQTMP+3
        RLC     A
        MOV     SQTMP+3,A
        DJNZ    R7,DSH16L
        RET
        

;********************************************************************************************************
; Ziehen der Quadratwurzel (ca. 820 s bei 22,1184 MHz)
; Prinzip: (b[7]+b[6]+b[5]+..+b[0])^2 = b[7]^2 + (2*b[7]+b[6])*b[6] + (2*(b[7]+b[6])+b[5])*b[5] + ..
; (b[7] = 2^7 = 128 oder 0, b[6] = 2^6 = 64 oder 0, .. , b[0] = 2^0 = 1 oder 0)
; Radikant in RADI (32 Bit)
; Ergebnis in ROOT (16 Bit)
; benutzte Register: A,R7,R6,R0
;********************************************************************************************************

SQRT16: CLR     A
        MOV     R7,#9
        MOV     R0,#SQTMP
SQ16L:  MOV     @R0,A           ; SQTMP und ROOT auf 0 setzen
        INC     R0
        DJNZ    R7,SQ16L

        MOV     R6,#15          ; Zhler
        CALL    DSH162          ; 2 Bit links
        MOV     A,SQTMP
        JZ      SQ161           ; 1. Ergebnisbit = 0
        INC     ROOT            ; 1. Ergebnisbit = 1
        SUBB    A,ROOT
        MOV     SQTMP,A
SQ161:  CALL    DSH162          ; 2 Bit links
        MOV     A,ROOT
        CLR     C
        RLC     A               ; 1 Bit links
        MOV     ROOT,A
        MOV     A,ROOT+1
        RLC     A               ; 1 Bit links
        MOV     ROOT+1,A
        MOV     A,ROOT
        SETB    C               ; nchstes Ergebnisbit probeweise setzen
        RLC     A               ; (2*a+b)*b
        MOV     SQTMP+4,A       ; zwischenspeichern
        MOV     A,ROOT+1
        RLC     A
        MOV     SQTMP+5,A       ; zwischenspeichern
        CLR     A
        RLC     A               
        MOV     SQTMP+6,A       ; zwischenspeichern
        
        MOV     A,SQTMP
        SUBB    A,SQTMP+4
        MOV     R7,A            ; zwischenspeichern
        MOV     A,SQTMP+1
        SUBB    A,SQTMP+5
        MOV     R0,A
        MOV     A,SQTMP+2
        SUBB    A,SQTMP+6
        JC      SQ162          ; Bit nicht setzen
        
        MOV     SQTMP+2,A       ; Subtraktionsergebnis speichern
        MOV     SQTMP+1,R0   
        MOV     SQTMP,R7
        INC     ROOT            ; Bit setzen
        MOV     A,ROOT
        JNZ     SQ162
        INC     ROOT+1    
SQ162:  DJNZ    R6,SQ161
        RET
                    
; Bytes umspeichern von Programmspeicher (DPTR) nach Datenspeicher (R0)
; MOVCD -  Anzahl der Bytes in R7
; MOVCD2 - 2 Bytes  (23s bei 12MHz)

MOVCD4: MOV     R7,#4
        SJMP    MOVCD
MOVCD2: MOV     R7,#2
MOVCD:  CLR     A
        MOVC    A,@A+DPTR
        INC     DPTR
        MOV     @R0,A
        INC     R0
        DJNZ    R7,MOVCD
        RET

