$NOLIST

; Include Datei

;********************************************************************************************************
; Lesen und Schreiben von Bytes ber die serielle Schnittstelle (direkt)
; J. Rathlev, Dez. 2003
;********************************************************************************************************

LF      EQU     0AH
CR      EQU     0DH
        
;********************************************************************************************************

        BSEG
        
Zf:     DBIT    1

        CSEG
                
;********************************************************************************************************
; Baudrateneinstellungen:
; SMOD = 1 ==> TH1 = 256 - (2 * f/Hz) / (384 * BR)

; 22,1184 MHz -   2400 : 208     24 MHz - 2400 : 204        12 MHz - 2400 : 230
;             -   4800 : 232            - 4800 : 230               - 4800 : 243
;             -   9600 : 244            - 9600 : 243
;             -  19200 : 250
;             -  38400 : 253
;             -  57600 : 254
;             - 115200 : 255

;********************************************************************************************************
; RS232 initalisieren

InitDefSer:
        MOV     A,#244          ; BR-Count (s.o.)
InitSerial:   
        MOV     TH1,A           ; load value

        MOV     A,TMOD
        ANL     A,#0FH
        ADD     A,#20H
        MOV     TMOD,A          ; timer 1 mode 2 (8 bit, auto-reload)
        CLR     SM0             ; serial mode 1 (8-bit)
        SETB    SM1
        SETB    TR1             ; start timer
        MOV     A,PCON
        ORL     A,#80H
        MOV     PCON,A          ; SMOD=1 (Baudrate x 2)
        SETB    REN             ; Enable receiver
        SETB    TI              ; set TI for transmit buffer empty
        CLR     RI              ; clear SI for receive interrupt
        RET

;********************************************************************************************************
; Ein Zeichen ber interne ser. Schnittstelle ausgeben
; Zeichen in A

WriteChar:
WWAIT:  JNB     TI,WWAIT        ; warten
        MOV     SBUF,A          ; Ausgabe
        CLR     TI
WRET:   RET

         
;********************************************************************************************************
; Nullterm. String in Daten-Speicher ber interne ser. Schnittstelle ausgeben 
; und Cr-Lf anhngen
; Zeiger auf String in DPTR

WriteString:
        MOVX    A,@DPTR
        INC     DPTR
        JZ      WriteCrLf
        ACALL   WRITECHAR
        SJMP    WRITESTRING
        
;********************************************************************************************************
; Cr+Lf (neue Zeile) ber interne ser. Schnittstelle ausgeben 

WriteCrLf:
        MOV     A,#CR
        ACALL   WRITECHAR
        MOV     A,#LF
        ACALL   WRITECHAR
        RET

;********************************************************************************************************
; Nulltem. String aus Code-Mem. ber interne ser. Schnittstelle ausgeben 
; Zeiger auf String in DPTR

WriteFixStr:
        CLR     A 
        MOVC    A,@A+DPTR
        INC     DPTR
        JZ      WFEND
        ACALL   WRITECHAR
        SJMP    WRITEFIXSTR
        
WFEND:  RET

;********************************************************************************************************
; Byte als Dezimalzahl ausgeben

; Wert in A
; Carry = 0 : mit fhrenden Nullen
;       = 1 : ohne fhrende Nullen

WRITEDEC:
        MOV     ZF,C            ; speicher Flag
        MOV     B,#100
        DIV     AB              ; 1. Stelle in A, Rest in B
        JZ      WD3
        CLR     ZF
        JMP     WD2             ; nicht Null
        
WD3:    JNB     ZF,WD2          ; mit fhrender 0
        JZ      WD1
WD2:    ADD     A,#30H          ; ASCII-Code
        CALL    WRITECHAR
WD1:    MOV     A,B
        MOV     B,#10
        DIV     AB              ; 2. Stelle
        JZ      WD6
        CLR     ZF
        JMP     WD5             ; nicht Null

WD6:    JNB     ZF,WD5          ; mit fhrender 0
        JZ      WD4
WD5:    ADD     A,#30H          ; ASCII-Code
        CALL    WRITECHAR
WD4:    MOV     A,B             ; 3. Stelle
        ADD     A,#30H          ; ASCII-Code
        CALL    WRITECHAR
        RET

;********************************************************************************************************
; Warten bis ein Zeichen von der seriellen Schnittstelle empfangen wurde
; Empfangenes Zeichen in A

READCHAR:
        JNB     RI,READCHAR     ; warten
        CLR     RI
        MOV     A,SBUF          ; Zeichen lesen
        RET

$LIST
