;$NOLIST
;
;********************************************************************************************************
; Ziehen der Quadratwurzel (16 Bit -> 8 Bit)
; J. Rathlev, Dez. 2003
; Diese Datei kann mit der Include-Anweisung in andere Programme integriert werden
;********************************************************************************************************

        DSEG

RADI:   DS      2
SQTMP:  DS      4
ROOT:   DS      1

;********************************************************************************************************

        CSEG

;********************************************************************************************************
; RADI nach links schieben, herausgeschobene Bits in SQTMP, von rechts wird mit 0 aufgefllt
; benutzte Register: A,R7
;********************************************************************************************************

SHFTL2: MOV     R7,#2           ; 2 Bit
SHFTL:  CLR     C
        MOV     A,RADI
        RLC     A
        MOV     RADI,A
        MOV     A,RADI+1
        RLC     A
        MOV     RADI+1,A
        MOV     A,SQTMP
        RLC     A
        MOV     SQTMP,A
        MOV     A,SQTMP+1
        RLC     A
        MOV     SQTMP+1,A
        DJNZ    R7,SHFTL
        RET
        

;********************************************************************************************************
; Ziehen der Quadratwurzel (ca. 240 s bei 22,1184 MHz)
; Prinzip: (b[7]+b[6]+b[5]+..+b[0])^2 = b[7]^2 + (2*b[7]+b[6])*b[6] + (2*(b[7]+b[6])+b[5])*b[5] + ..
; (b[7] = 2^7 = 128 oder 0, b[6] = 2^6 = 64 oder 0, .. , b[0] = 2^0 = 1 oder 0)
; Radikant in RADI (16 Bit)
; Ergebnis in ROOT (8 Bit)
; benutzte Register: A,R7,R6
;********************************************************************************************************

SQRT8:  CLR     A
        MOV     SQTMP,A         ; auf 0 setzen
        MOV     SQTMP+1,A
        MOV     SQTMP+2,A
        MOV     SQTMP+3,A
        MOV     ROOT,A
        MOV     R6,#7           ; Zhler
        CALL    SHFTL2          ; 2 Bit links
        MOV     A,SQTMP
        JZ      SQRT81          ; 1. Ergebnisbit = 0
        INC     ROOT            ; 1. Ergebnisbit = 1
        SUBB    A,ROOT
        MOV     SQTMP,A
SQRT81: CALL    SHFTL2          ; 2 Bit links
        MOV     A,ROOT
        RL      A               ; 1 Bit links
        MOV     ROOT,A
        SETB    C               ; nchstes Ergebnisbit probeweise setzen
        RLC     A               ; (2*a+b)*b
        MOV     SQTMP+2,A       ; zwischenspeichern
        CLR     A
        RLC     A
        MOV     SQTMP+3,A
        MOV     A,SQTMP
        SUBB    A,SQTMP+2
        MOV     R7,A            ; zwischenspeichern
        MOV     A,SQTMP+1
        SUBB    A,SQTMP+3
        JC      SQRT82          ; Bit nicht setzen
        MOV     SQTMP+1,A       ; Subtraktionsergebnis speichern
        MOV     SQTMP,R7
        INC     ROOT            ; Bit setzen
SQRT82: DJNZ    R6,SQRT81
        RET

$LIST
